#include <stdio.h>

#ifdef NETBSD
#include <sys/param.h>
#include <sys/sysctl.h>
#else
#ifdef LINUX
#else
#include <rpc/rpc.h>
#include <rpcsvc/rstat.h>
#endif /* LINUX */
#endif /* NETBSD */

getboottime(boottime)
    long *boottime;
{
#ifdef NETBSD
    int			mib[2];	/* Management Information Base */
    struct timeval	bootinfo;
    int			size;

    mib[0] = CTL_KERN;
    mib[1] = KERN_BOOTTIME;
    size = sizeof(bootinfo);
    if (sysctl(mib, 2, &bootinfo, &size, NULL, 0) != -1 &&
	bootinfo.tv_sec != 0)
    {
	*boottime = bootinfo.tv_sec;
	return 1;
    }
    else
	return -1;
#else
#ifdef LINUX
    FILE *fp;
    double uptime;
    long curtime;
    
    fp = fopen("/proc/uptime", "r");
    if (fp == NULL)
	return -1;

    time(&curtime);
    if (fscanf(fp, "%lf", &uptime) != 1)
    {
	fclose(fp);
	return -1;
    }

    *boottime = curtime - ((long) uptime);
    
    fclose(fp);
    return 1;
#else
    struct statstime statp;

    if (rstat("localhost", &statp) != 0)
	return -1;
    
    *boottime = statp.boottime.tv_sec;

    return 0;
#endif
#endif

    
}
